package id3info;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.Dialog.ModalityType;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.WindowConstants;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;


public class MainForm extends JFrame {
	private JList zoznamSuborov;
	private JLabel artistLabel;
	private JLabel trackLabel;
	private JLabel artist;
	private JLabel track;
	private Mp3ListModel mp3ListModel;

	public MainForm() {
		File directory = new File("d:/MP3/Kapela ze wsi Warszawa/2009 Infinity");

		setBounds(0, 0, 640, 480);
		setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
		
		mp3ListModel = new Mp3ListModel(directory); 
		
		zoznamSuborov = new JList(mp3ListModel);
		zoznamSuborov.setCellRenderer(new Mp3ListCellRenderer());
		
		zoznamSuborov.setBounds(0, 0, 400, 400);
		zoznamSuborov.addListSelectionListener(new ListSelectionListener() {
			@Override
			public void valueChanged(ListSelectionEvent e) {
				zoznamSuborovValueChanged(e);
			}
		});
		
		add(zoznamSuborov, BorderLayout.CENTER);
		
		JPanel id3Panel = new JPanel();
		id3Panel.setLayout(new GridLayout(0, 1));
		add(id3Panel, BorderLayout.PAGE_END);
		
		artistLabel = new JLabel("Artist:");
		id3Panel.add(artistLabel);
		
		artist = new JLabel("XXX");
		id3Panel.add(artist);

		trackLabel = new JLabel("Track:");
		id3Panel.add(trackLabel);
		
		track = new JLabel("XXX");
		id3Panel.add(track);

		JButton zobrazInfo = new JButton("Zobraz info!");
		zobrazInfo.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				zoznamInfoActionPerformed(e);
			}
		});
		id3Panel.add(zobrazInfo, BorderLayout.PAGE_END);
		
		JButton aktualizuj = new JButton("Aktualizova");
		aktualizuj.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				aktualizujActionPerformed(e);
			}
		});
		id3Panel.add(aktualizuj);
		
		addWindowListener(new WindowAdapter() {			
			@Override
			public void windowActivated(WindowEvent e) {
				onWindowActivated(e);
			}
		});
	}

	protected void onWindowActivated(WindowEvent e) {
		mp3ListModel.refresh();		
	}

	protected void zoznamSuborovValueChanged(ListSelectionEvent e) {
		File subor = (File) zoznamSuborov.getSelectedValue();
		artist.setText(subor.getName());
		track.setText(Long.toString(subor.length()));	
	}
	
	public void zoznamInfoActionPerformed(ActionEvent e) {
		Id3DetailForm id3DetailForm = new Id3DetailForm(MainForm.this);
		id3DetailForm.setModalityType(ModalityType.DOCUMENT_MODAL);
		id3DetailForm.setVisible(true);
		
		if(id3DetailForm.isStlacilSomOk()) {
			System.out.println("OK");
		}		
	}

	public void aktualizujActionPerformed(ActionEvent e) {
		mp3ListModel.refresh();
	}
}
