package id3info;
import java.io.File;
import java.io.FileFilter;
import java.util.LinkedList;
import java.util.List;

import javax.swing.AbstractListModel;

public class Mp3ListModel extends AbstractListModel {

	private File mp3Adresar;

	private File[] mp3Files;

	public Mp3ListModel(File mp3Adresar) {
		this.mp3Adresar = mp3Adresar;
		refresh();
	}

	public void refresh() {
		this.mp3Files = mp3Adresar.listFiles(new Mp3FileFilter());
		fireContentsChanged(this, 0, this.mp3Files.length - 1);
	}

	@Override
	public Object getElementAt(int index) {
		return mp3Files[index];
	}

	@Override
	public int getSize() {
		return mp3Files.length;
	}

	private static class Mp3FileFilter implements FileFilter {
		@Override
		public boolean accept(File pathname) {
			return pathname.getName().endsWith(".mp3");
		}
	}
}
